<?php
defined(page_security_key) or exit;

if (debug && debug_id == $_SESSION['id']){
    ini_set('display_errors', '1');
    ini_set('display_startup_errors', '1');
    error_reporting(E_ALL);  
}

include_once './assets/functions.php';
include_once './settings/settings_redirector.php';

//SET ORIGIN FOR NAVIGATION
$prev_page = $_SESSION['prev_origin'] ?? '';
$page = $_SESSION['origin'] = 'catalog';

//Check if allowed
if (isAllowed($page,$_SESSION['profile'],$_SESSION['permission'],'R') === 0){
    header('location: index.php');
    exit;
}

//GET PARAMETERS
$pagination_page = isset($_GET['p']) ? $_GET['p'] : 1;
$search = isset($_GET['search']) ? '&search='.$_GET['search'] : '';

// Determine the URL
$url = 'index.php?page=catalog'.$search;
//GET Details from URL
$GET_VALUES = urlGETdetails($_GET) ?? '';

//Get all the categories from the database
$categories = ioServer('/v2/categories/','');
$categories = json_decode($categories,true);

//IF CATEGORY IS RECEIVED ONLY GET RELATED PRODUCTS
$url_input = '';
if(isset($_GET['category']) && !isset($_POST['category'])){
    $url_input = 'category='.$_GET['category'];
}

if (isset($_POST['category'])){
    
    $filter_input = '';

    foreach (array_keys($_POST['category']) as $cat_filter){
        $filter_input .= $cat_filter.',';
    }

    if ($url_input != ''){
        $url_input = $url_input.','.substr($filter_input,0, -1);

    } else {
        $url_input = 'category='.substr($filter_input,0, -1);
    }
} 

//GET CATALOG DATA
$products = ioServer('/v2/catalog/'.$url_input,'');
$products = json_decode($products,true);

//Return QueryTotal from API
$query_total = ioServer('/v2/products/'.$GET_VALUES.'&totals=&salesflag=1&status=1','');
$query_total = json_decode($query_total,true);

template_header('Catalog', 'catalog','view');
$view = '
<div class="content-title">
    <div class="title">
        <i class="fa-solid fa-box-open"></i>
        <div class="txt">
            <h2>'.($catalog_h2 ?? 'Catalog').' ('.$query_total.')</h2>
            <p>'.($catalog_p ?? '').'</p>
        </div>
    </div>
</div>';

if (isset($success_msg)){
$view .= ' <div class="msg success">
                <i class="fas fa-check-circle"></i>
                <p>'.$success_msg.'</p>
                <i class="fas fa-times"></i>
            </div>';
}

$view .= '
<div class="filtersection">
    
    <!-- Filter Section -->
    <div class="filter-section">
    <form action="" method="post">
        <h2>'.($products_filters_h2 ?? 'Filter Products').'</h2>';
        
        if (count($categories) > 0){
            //BUILD UP FILTERS BASED ON CATEGORY ASSIGNMENTS
            foreach ($categories as $filters){
        
                if ($filters['parent_id'] == '0' && $filters['status'] == 1 && $filters['filter'] == 1){
                    $view .= '<div class="filter-group">
                                <label>'.(${$filters['name']} ?? $filters['name']).'</label> ';
                                //Iterate through categories for subfilters
                                foreach ($categories as $subfilter){
                                    if ($filters['rowID'] == $subfilter['parent_id'] && $subfilter['status'] == 1 && $subfilter['filter'] == 1){
                                    $view .= '<div>
                                                    <input type="checkbox" id="'.$subfilter['name'].'" name="category['.$subfilter['rowID'].']">
                                                    <label for="'.$subfilter['name'].'">'.(${$subfilter['name']} ?? $subfilter['name']).'</label>
                                                </div>';
                                    }
                                }
                    $view .= '</div>';  
                }
            }
            $view .= '<input type="submit" value="'.($btn_filter ?? 'Filter').'" class="btn" >';
        }
$view .= '</form>
        </div>

    <div class="products content-wrapper"> ';

//ADD CATEGORIES
$view .= ' <div style="margin-top: 30px;display: flex;align-items: center;align-content: center;flex-wrap: nowrap;flex-direction: column;">
            <div class="product_category_nav">
            ';         
                foreach ($categories as $categorie){
                    if ($categorie['parent_id'] == '0' && $categorie['status'] == 1 && $categorie['filter'] != 1){
                        $weburl = url('index.php?page=products&category='.$categorie['rowID'].'');  
                    $view .= '<a href="'.$weburl.'">'.(${$categorie['name']} ?? $categorie['name']).'</a>';           
                    }
                }   
          $view .= '
            </div>';
            if (isset($_GET['category'])){
                $view .= '<div class="product_category_nav">';
                
                foreach ($categories as $categorie){
                    if ($categorie['parent_id'] == $_GET['category'] && $categorie['status'] == 1 && $categorie['filter'] != 1){  
                        $weburl = url('index.php?page=productsnew&category='.$categorie['rowID'].'');  
                        $view .= '<a href="'.$weburl.'" style="color: #fff;background-color: #555555;font-size: 10px;">'.(${$categorie['name']} ?? $categorie['name']).'</a>';           
                    }
                }   
                $view .= '</div>';
            }
            
        $view .= '
        </div>'; 

        
$view .= '<div class="products-wrapper">';

        foreach ($products as $product){

            // Ensure product price is a numeric value
            $product_price = isset($product['price']) && $product['price'] > 0 ? floatval($product['price']) : 0.00;
        
            //SHOW LARGE PICTURE
            $view .= '
            <div class="product">
                <a href="'.url('index.php?page=product&rowID=' . ($product['url_slug'] ? ($product['url_slug'] ) : $product['rowID'])).'" id="'.$product['rowID'].'A" class="product">                        
                    <img src="'.$product['full_path'].'" id="'.$product['rowID'].'"  style="max-width: 250px;max-height: 250px;width: auto;height: auto;" alt="'.(${$product['productname']} ?? $product['productname']).'">
                </a>';

            //CHECK IF CONFIGURATION SETTING IS FOUND AND NOT EMPTY => USE GROUP TO DISPLAY IMAGES
            if (isset($product['configurations']) && isset($product['config_setting']) && $product['config_setting'] != ''){
                
                
                //GET THE CONFIG_SETTING GROuP AND DISPLAY
                foreach ($product['configurations'] as $config){

                    //MATCH ASSIGNMENT WITH CONFIG SETTING
                    if($config['assignment'] == $product['config_setting']){

                        $view .= '<div class="" style="display:flex;justify-content: center">';
                        
                        //GET ALL RELATED ATTRIBUTES
                        foreach ($config['attributes'] as $attribute){
                            $option_id = $attribute['attribute_id']; // ID of the LARGE IMAGE
                            $IMG_small_id = $attribute['full_path']; //URL TO SMALL IMAGE
                            $IMG_large_id = $attribute['alternative_media_full_path']; //URL TO LARGE IMAGE
                    
                            // Ensure attribute price is a numeric value
                            $attribute_price = isset($attribute['price']) ? floatval($attribute['price']) : 0.00;
                        
                            $option_price = isset($attribute['price']) 
                            // If price modifier is 1, add prices; otherwise, subtract
                            ? ((isset($attribute['price_modifier']) && $attribute['price_modifier'] == 1) ?  number_format(floatval($product_price + $attribute_price), 2) :  number_format(floatval($product_price - $attribute_price), 2))
                            // If product price is not zero, format it
                            : (($product_price != 0.00) ?  number_format(floatval($product_price), 2) : '');

                            $view .= '
                            <div>
                                <img class="img_config" src="'.$IMG_small_id.'" id="'.$attribute['item_media'].'" onclick="update(\''.$product['rowID'].'\',\''.$IMG_large_id.'\',\''.url('index.php?page=product&rowID=' . ($product['url_slug'] ? $product['url_slug'].'/'.$option_id  : $product['rowID'].'/'.$option_id )).'\',\''.$option_price.'\')" />
                            </div>';
                        }

                        $view .= '</div>';
                    
                    }
                }
                
            } else {
                //SHOW SMALL IMAGE
                $view .= '<div class="" style="display:flex;justify-content: center">
                            <div>
                                <img class="img_config" src="'.$product['full_path'].'"/>
                            </div>
                        </div>';
            }         

        //Stock status   
        $stock_status = (isset($product['quantity']) && $product['quantity'] != 0) ? $product_on_stock : $out_of_stock;
        $style = ($stock_status == $product_on_stock) ? 'style="background-color: green;"' : 'style="background-color:gray;font-weight: lighter;"';

        $view .= '
            <span class="stock">
                <p '.$style.'> '.$stock_status.'</p>
            </span>';

            /*if (free_shipment_indicator){
                $shipment = freeShipment($product_price,'span');
                $view .= $shipment;
            }*/
        $option_id ='';
        $view .='<a href="'.url('index.php?page=product&rowID=' . ($product['url_slug'] ? $product['url_slug'].$option_id  : $product['rowID'])).'" id="'.$product['rowID'].'B" class="product">
                <span class="name">'.(${$product['productname']} ?? $product['productname']).'</span>';

                if (isset($product_price)){

                    $view .= '<span class="price" id="'.$product['rowID'].'C">'.(($product_price != 0.00) ? number_format($product_price,2) : '').'';
                        
                    if (isset($product['rrp']) && $product['rrp'] > 0){
                            $view .= '<span class="rrp">'.number_format($product['rrp'],2).'</span>';
                        }
                $view .= '</span>';
                }
        $view .= '
                </a>
        </div>';
        }

    $view .= '
    </div>';

    $view .= '
            </div>
    </div>';

$view .= '<script>
            function update(id_large, IMG_large, option_id, price){
            let url_id_a = id_large + \'A\';
            let url_id_b = id_large + \'B\';
            let url_id_c = id_large + \'C\';
            
            //change picture
            document.getElementById(id_large).src = IMG_large;
            document.getElementById(url_id_a).href =  option_id;
            document.getElementById(url_id_b).href =  option_id;  
            document.getElementById(url_id_c).innerHTML =  price;
            document.getElementById(url_id_c).style =  price;  
            }
            </script>';

$view.='<div class="pagination">';
if ($pagination_page > 1) {
    $page = $pagination_page-1;
    $view .= '<a href="'.$url.'&p=1">'.$general_first.'</a>';
    $view .= '<a href="'.$url.'&p='.$page.'">'.$general_prev.'</a>';
}
$totals = ceil($query_total / $page_rows_products) == 0 ? 1 : ceil($query_total / $page_rows_products);
$view .= '<span> '.$general_page.$pagination_page.$general_page_of.$totals.'</span>';
if ($pagination_page * $page_rows_products < $query_total){
    $page = $pagination_page+1;
    $view .= '<a href="'.$url.'&p='.$page.'">'.$general_next.'</a>';
    $view .= '<a href="'.$url.'&p='.$totals.'">'.$general_last.'</a>';

}
$view .= '</div>';
//OUTPUT
echo $view;

template_footer();
?>